#!/usr/bin/perl
# teste scn bibliothek
use strict;
use warnings;
use loadscan;
use Gtk2 -init;
use Data::Dumper;

# filename (*.par)
my $name=shift(@ARGV) || select_file();

# forward (f) oder backward (b) scan nutzen
my $direct= shift(@ARGV) || 'f';
$loadscan::scan_direction='forward' if ($direct eq 'f');
$loadscan::scan_direction='backward' if ($direct eq 'b');

die "Bitte pfad angeben!" unless($name);

my $scan=loadscan->new($name);
die ("ERROR open $name ($!)") unless($scan);

my $min=$scan->get_real_min_deep();
my $max=$scan->get_real_max_deep();

my $pixbuf=convert($scan->get_matrix(),$min,$max);

die("Error No Pixbuf") unless($pixbuf);

show_img($pixbuf);
Gtk2->main;

########################################################################
# convert data:

sub convert
{
  my $matix=shift || return undef;
  my $min=shift || 0;
  my $max=shift || 2;

  ($max,$min)=($min,$max) if($min>$max);

  my $multi=255/($max-$min);
  # Daten konvertieren
  my $data;
  for my $line (@$matix)
  {
    for my $z (@$line)
    {
      my $val=($z-$min)*$multi;
      #print "$val\n";
      $val=0 if($val<0);
      $val=255 if($val>255);
      $data.=pack('C*',$val,$val,$val);
    }
  }
  my $h=@$matix;
  my $w=@{$matix->[0]};
  return Gtk2::Gdk::Pixbuf->new_from_data($data,'GDK_COLORSPACE_RGB',0,8,$w,$h,($w)*3)
}


########################################################################
# Filecooser
sub select_file
{
  my $filename=undef;
  my $file_chooser = Gtk2::FileChooserDialog->new(
                            'This is the spiffy new file chooser!',
                            undef, 'open',
                            'gtk-cancel' => 'cancel',
                            'gtk-ok' => 'ok');

  if ('ok' eq $file_chooser->run)
  {
    $filename = $file_chooser->get_filename;
  }

  $file_chooser->destroy;
  return $filename;
}
########################################################################
# Ein bild anzeigen
sub show_img
{
  my $pixbuf=shift;
  my $title=shift || "BILD";
  # Ein Bilddialog erzeugen
  # Hat nur einen closebutton
  # Ist nicht Modal
  my $dialog = Gtk2::Dialog->new( $title,
                                  undef,
                                  'destroy-with-parent',
                                  'gtk-ok' => 'accept',
                                  'gtk-save' => 'apply'
                                );

  $dialog->signal_connect(response => sub {
    if($_[1] eq 'apply')
    {
      my $file='out';
      my $format='png';
      my $count=0;
      while(-e "$file.$count.$format"){ $count++; }
      $pixbuf->save("$file.$count.$format", $format);
    }
    else
    {
      $dialog->destroy;
      exit();
    }
    1;
  });

  my $text=Gtk2::Label->new('LEEER');
  $text->set (yalign => 0, xalign => 0 );
  $dialog->vbox()->pack_start($text,1,1,0);

  my $ebox = Gtk2::EventBox->new;
  my $align = Gtk2::Alignment->new (0.5, 0.5, 0.0, 0.0);
  my $image=Gtk2::Image->new_from_pixbuf($pixbuf);

  $ebox->add_events (['pointer-motion-mask', 'pointer-motion-hint-mask']);
  $ebox->signal_connect (motion_notify_event => sub{
    my ($widget, $event) = @_;
    # this is so we keep getting pointer events.
    $widget->window->get_pointer;
    # the Gtk2::Image is a no-window widget; translate its coords.
    # it should be packed tightly in the event box, thanks to the
    # alignment, but this is for paranoia's sake.
    my ($x, $y) = $widget->translate_coordinates ($image, $event->x, $event->y);

    $text->set_text("X/Y/Z = $x/$y/".$scan->get_deep_at_pos($x,$y));
  });

  $ebox->add($image);
  $align->add ($ebox);
  $dialog->vbox()->pack_start($align,1,1,0);

  $dialog->show_all();
  return 1;
}

# Alles Beenden
sub exit
{ Gtk2->main_quit; }
